****************************************************************************************************			
* Pantalla "std" 	$0c00-$23ff - SAM offset = $0c00 / $200 =  6 = #%0000110 - valor por defecto
* buffer				$2400-3bff	- SAM offset = $2400 / $200 = 18 = #%0010010
****************************************************************************************************			
			opt	cd
			opt	ct
			org	$4500					; donde ubicar el programa
inicio	sts	$0114
			tfr	cc,a
			tfr	dp,b
			std	CcDp
			orcc	#$50					; deshabilita interrupciones
			lda	#$4					; poner a uno los bits 0 y 2
			sta	$ff03					; para detectar FS al final de pantalla

			ldx	#$0c00				; origen de pantalla (inicial donde est imagen a mover)
			stx	origen				; guardar puntero
			ldx	#$2400				; destino sin desplazar
			stx	destino				; guardar puntero
			ldb	#192					; filas a desplazar para mover toda la pantalla
			stb	>$0076				; guardar en variable pagina 0

			opt 	cc
S1			lda	#191					; numero de lineas a hacer scroll (la ltima NO)
			sta	>$0077				; guardar en variable pagina 0
			clra
			clrb
			lds	#0						; tomar doble cero
			ldx	#0
			ldy	#0
			ldu	destino
			leau	32,u
			pshu	d,x,y,s
			pshu	d,x,y,s
			pshu	d,x,y,s
			pshu	d,x,y,s				; limpiar los 32 bytes de la primera linea

			lds	origen				; points to beginning of ORIGIN line
;			ldu	destino				; points to 8th byte next DESTination line
			leau	40,u
			
			opt	cc
Cpy1L		puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes
			leau  16,u					; to point to next 8 bytes
			puls  cc,dp,x,y,d			; copies 8 bytes ($c00-$c07)
			pshu  cc,dp,x,y,d			; puts in buffer these 8 bytes. ONE line copied
			leau  16,u					; to point to next 8 bytes
			dec	>$0077					; decrement counter
			bne	Cpy1L					; not yet done, loop
			
			opt 	cc
			lda	$ff02					; limpiar indicador de interrupcin
eHs		lda	$ff03					; lleg interrupcin HSYNC? (la de final de pantalla!)
			bpl	eHs					; esperar
											; cambiar inicio de pantalla en SAM
cambio	lda	>$0076				; lee contador numero de scrolls a realizar (+1)
			anda	#1						; usa bit cero
			beq	par					; si es par mostrar buffer
											; si es impar mostrar 'std'
impar		sta	$ffcb					; 1
			sta	$ffce					; 0 = #%0000110 = 6 (valor x defecto)
			bra	actPun				; salta codigo para Pares
par		sta	$ffca					; 0
			sta	$ffcf					; 1 = #%0010010 = 18 (valor x buffer)
											; cambiar punteros
actPun	ldx	destino				; toma destino (nuevo origen)
			ldy	origen				; toma origen (nuevo destino)
			sty	destino				; actualiza destino actual
			stx	origen				; actualiza origen actual
			dec	>$0076				; movida la imagen completa?
			lbne	S1						; no, siguiente pixel abajo
			lds	$0114
			ldd	CcDp
			tfr	a,cc
			tfr	b,dp
			rts							; retorna
****************************************************************************************************
origen	fdb	$0000
destino	fdb	$0000
CcDp		fdb	$0000
			end 	inicio
